Bug 1813187 - ghostscript does not load variable fonts from fontconfig
Summary: ghostscript does not load variable fonts from fontconfig
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: ghostscript
Version: 32
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Richard Lescak
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1813230
TreeView+ depends on / blocked
 
Reported: 2020-03-13 07:59 UTC by Zdenek Dohnal
Modified: 2021-05-25 15:47 UTC (History)
11 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1813230 (view as bug list)
Environment:
Last Closed: 2021-05-25 15:47:09 UTC
Type: Bug


Attachments (Terms of Use)

Description Zdenek Dohnal 2020-03-13 07:59:29 UTC
Description of problem:
During investigating https://bugzilla.redhat.com/show_bug.cgi?id=1722900 was found the font mentioned in summary fails with mismatch on FcPatternGetInteger() from fontconfig when gs asks for FC_WEIGHT value.
I'm not sure whether the font or fontconfig is at fault, so I'm filing the issue on font package.

I'm willing to help with debug, if needed.

Version-Release number of selected component (if applicable):
abattis-cantarell-fonts-0:0.201-2.fc32.noarch
fontconfig-2.13.92-6.fc32.x86_64
ghostscript-9.50-1.fc32

Steps to Reproduce:
1. gs -dNODISPLAY -dBATCH nasmdoc.ps


Actual results:
You can see in logs a message:

DEBUG: FC_WEIGHT didn't match in /usr/share/fonts/cantarell/Cantarell-VF.otf

Expected results:
No such message

Additional info:

Comment 1 Kalev Lember 2020-03-13 08:32:41 UTC
Sorry, I don't know much about fonts and don't think I can be of much help debugging this. Can you ask Jakub and/or Tagoh if they know what's going on (CCd)?

Comment 2 Nicolas Mailhot 2020-03-13 08:42:52 UTC
On the fontconfig side, that’s basically bug
https://gitlab.freedesktop.org/fontconfig/fontconfig/issues/222

No idea if gs also contains problematic weight assumptions, invalidated by the introduction of variable fonts.

On the packaging side cantarell has probably not been converted to new font packaging guidelines yet. It needs some name fixing (use of a space-free ExtraBold qualifier, removal of Regular in Name ID 4 for the Regular face, making NameID 4 consistent with Name ID 17 for other faces). Though except for the ExtraBold part, everything else will going to be workarounded in future fontconfig versions.

Comment 3 Nicolas Mailhot 2020-03-13 08:52:38 UTC
(Also fontconfig exposes a generic meta face for variable fonts, this face does not have any specific weight, it gives the weight scale for the whole family)

Comment 4 Akira TAGOH 2020-03-13 08:58:05 UTC
That isn't related to this.

I don't know how ghostscript collects fonts from fontconfig though (probably using FcFontList()?), the problem here would be that they have dealt with a meta face as a normal face which has true in FC_VARIABLE and contains a weight in range but not integer.

That's not a bug in font nor fontconfig.

Comment 5 Zdenek Dohnal 2020-03-13 09:25:03 UTC
Hi Akira,

yes, you're right, gs uses FcFontlist() - does the following to get font list:

-----------------------------------------------------
    /* load the font set that we'll iterate over */
    pat = FcPatternBuild(NULL,
            FC_OUTLINE, FcTypeBool, 1,
            FC_SCALABLE, FcTypeBool, 1,
            NULL);
    os = FcObjectSetBuild(FC_FILE, FC_OUTLINE,
            FC_FAMILY, FC_WEIGHT, FC_SLANT,
            NULL);
    state->font_list = FcFontList(0, pat, os);
-----------------------------------------------------

then when it enumerates the fonts it calls (f.e. for FC_WEIGHT):

result = FcPatternGetInteger (font, FC_WEIGHT, 0, &weight_fc);

(similar thing for FC_FILE, FC_FAMILY, FC_SLANT, FC_OUTLINE).

Would you mind telling me/pointing me to a manual how to deal with it correctly, if it is not a problem of font/fontconfig?

Comment 6 Akira TAGOH 2020-03-13 10:07:42 UTC
If ghostscript has no plans to support variable fonts or a plan to support only named-instances, you can set false to FC_VARIABLE 
 as a query pattern; that should be more simple and easier than your patch applied in ghostscript; you can take care of the named-instances in VF font files as same as usual face then. otherwise set FcDontCare to FC_VARIABLE and need more changes in the code to deal with non-named-instances perhaps.

The meta face which you faced the issue this time provides such information instead of providing it as one of faces because there are so many patterns to enummerate everything and quite hard to do. the targetted properties such as FC_WEIGHT, FC_WIDTH and FC_SIZE has a value in FcRange which means they can use an unique value between them.

Unfortunately there are no more detailed document though, pango source code may helps how to deal with them.

Comment 7 Akira TAGOH 2020-03-13 10:16:22 UTC
You can see what values the meta face provides. try fc-list -b -v Cantarell:variable=true for example.

Comment 8 Zdenek Dohnal 2020-03-13 10:40:41 UTC
IMO they are not aware of the fact the variable fonts need a special care when are used from fontconfig.

I'll check with upstream about variable fonts then.

Thank you for the info!

Comment 9 Anna Khaitovich 2020-04-15 09:41:53 UTC
ghostscript-9.52 already has a workaround for this issue (see upstream commit - [1]), fix is already prepared and waiting for upstream approval ([2]), so moving this bug to POST.


[1] https://git.ghostscript.com/?p=ghostpdl.git;a=commit;h=09a575f0fdc6edde7e42f325167318a1b199839f
[2] https://bugs.ghostscript.com/show_bug.cgi?id=702225

Comment 10 Fedora Admin user for bugzilla script actions 2021-01-26 00:06:15 UTC
This package has changed maintainer in Fedora. Reassigning to the new maintainer of this component.

Comment 11 Fedora Program Management 2021-04-29 16:14:21 UTC
This message is a reminder that Fedora 32 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 32 on 2021-05-25.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '32'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 32 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 12 Fedora Admin user for bugzilla script actions 2021-05-04 12:09:26 UTC
This package has changed maintainer in Fedora. Reassigning to the new maintainer of this component.

Comment 13 Ben Cotton 2021-05-25 15:47:09 UTC
Fedora 32 changed to end-of-life (EOL) status on 2021-05-25. Fedora 32 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.